"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var fs_extra_promise_1 = require("fs-extra-promise");
var globby = require('globby');
var NsisComposer = (function () {
    function NsisComposer(options) {
        this.options = options;
        this.fixedVersion = this.fixVersion(this.options.version);
    }
    NsisComposer.prototype.make = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = NsisComposer.DIVIDER + "\n#\n# Generated by nsis-gen.\n#\n" + NsisComposer.DIVIDER + "\n\n";
                        return [4 /*yield*/, this.makeGeneralSection()];
                    case 1:
                        _b = _a + (_e.sent()) + "\n";
                        return [4 /*yield*/, this.makeResourcesSection()];
                    case 2:
                        _c = _b + (_e.sent()) + "\n";
                        return [4 /*yield*/, this.makeInstallSection()];
                    case 3:
                        _d = _c + (_e.sent()) + "\n";
                        return [4 /*yield*/, this.makeUninstallSection()];
                    case 4: return [2 /*return*/, _d + (_e.sent()) + "\n"];
                }
            });
        });
    };
    NsisComposer.prototype.makeGeneralSection = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, NsisComposer.DIVIDER + "\n#\n# General\n#\n" + NsisComposer.DIVIDER + "\n\nName \"" + this.options.appName + "\"\nCaption \"" + this.options.appName + "\"\nBrandingText \"" + this.options.appName + "\"\nOutFile \"" + path_1.win32.normalize(path_1.resolve(this.options.output)) + "\"\nInstallDir \"$PROGRAMFILES\\" + this.options.appName + "\"\nSetCompressor " + (this.options.solid ? '/SOLID' : '') + " " + this.options.compression + "\nXPStyle on\n"];
            });
        });
    };
    NsisComposer.prototype.makeResourcesSection = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, NsisComposer.DIVIDER + "\n#\n# Resources\n#\n" + NsisComposer.DIVIDER + "\n\nVIProductVersion \"" + this.fixedVersion + "\"\nVIAddVersionKey \"ProductName\" \"" + this.options.appName + "\"\nVIAddVersionKey \"CompanyName\" \"" + this.options.companyName + "\"\nVIAddVersionKey \"FileDescription\" \"" + this.options.description + "\"\nVIAddVersionKey \"FileVersion\" \"" + this.fixedVersion + "\"\nVIAddVersionKey \"LegalCopyright\" \"" + this.options.copyright + "\"\n"];
            });
        });
    };
    NsisComposer.prototype.makeInstallSection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = NsisComposer.DIVIDER + "\n#\n# Main\n#\n" + NsisComposer.DIVIDER + "\n\nSection -Install\n\nSetShellVarContext current\nSetOverwrite ifnewer\n\n";
                        return [4 /*yield*/, this.makeInstallerFiles()];
                    case 1: return [2 /*return*/, _a + (_b.sent()) + "\n\nWriteUninstaller \"$INSTDIR\\uninstall.exe\"\n\nSectionEnd\n"];
                }
            });
        });
    };
    NsisComposer.prototype.makeUninstallSection = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, NsisComposer.DIVIDER + "\n#\n# Uninstall\n#\n" + NsisComposer.DIVIDER + "\n\nSection Uninstall\n\nRMDir /r \"$INSTDIR\\*.*\"\nRMDir \"$INSTDIR\"\n\nSectionEnd\n"];
            });
        });
    };
    NsisComposer.prototype.makeInstallerFiles = function () {
        return __awaiter(this, void 0, void 0, function () {
            var out;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        out = [];
                        return [4 /*yield*/, this.readdirLines(path_1.resolve(this.options.srcDir), path_1.resolve(this.options.srcDir), out)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, out.join('\n')];
                }
            });
        });
    };
    NsisComposer.prototype.fixVersion = function (version) {
        // Fix "invalid VIProductVersion format, should be X.X.X.X" for semver.
        return /^\d+\.\d+\.\d+$/.test(this.options.version) ? this.options.version + ".0" : this.options.version;
    };
    NsisComposer.prototype.readdirLines = function (dir, baseDir, out) {
        return __awaiter(this, void 0, void 0, function () {
            var lines, pendingFiles, files, path, _i, files_1, file, path, stat, _a, pendingFiles_1, file;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        lines = [];
                        pendingFiles = [];
                        return [4 /*yield*/, fs_extra_promise_1.readdirAsync(dir)];
                    case 1:
                        files = _b.sent();
                        if (files.length > 0) {
                            path = path_1.win32.normalize(path_1.relative(baseDir, dir));
                            lines.push("SetOutPath \"$INSTDIR" + (path == '.' ? '' : "\\" + path) + "\"");
                        }
                        _i = 0, files_1 = files;
                        _b.label = 2;
                    case 2:
                        if (!(_i < files_1.length)) return [3 /*break*/, 5];
                        file = files_1[_i];
                        path = path_1.resolve(dir, file);
                        return [4 /*yield*/, fs_extra_promise_1.lstatAsync(path)];
                    case 3:
                        stat = _b.sent();
                        if (stat.isFile()) {
                            lines.push("File \"" + path_1.win32.normalize(path) + "\"");
                        }
                        else if (stat.isDirectory()) {
                            pendingFiles.push(path);
                        }
                        _b.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5:
                        _a = 0, pendingFiles_1 = pendingFiles;
                        _b.label = 6;
                    case 6:
                        if (!(_a < pendingFiles_1.length)) return [3 /*break*/, 9];
                        file = pendingFiles_1[_a];
                        return [4 /*yield*/, this.readdirLines(path_1.resolve(dir, file), path_1.resolve(baseDir), lines)];
                    case 7:
                        _b.sent();
                        _b.label = 8;
                    case 8:
                        _a++;
                        return [3 /*break*/, 6];
                    case 9:
                        out.push.apply(out, lines);
                        return [2 /*return*/];
                }
            });
        });
    };
    return NsisComposer;
}());
NsisComposer.DIVIDER = '################################################################################';
exports.NsisComposer = NsisComposer;
//# sourceMappingURL=NsisComposer.js.map